# call of the printer driver dvilj with the file $main_file, output into $prt_file
#
# Copyright (C) 1994  G. Lamprecht, W. Lotz, R. Weibezahn; LRW c/o Uni Bremen
# Copyright (C) 1996  G. Lamprecht, W. Lotz, R. Weibezahn; IWD, Bremen University

proc prt_dvilj {f austext} {

  upvar 1 $austext a

  global vv main_file prtoptions pg_start pg_end prmsel prt_file opsep printcops dirprefix
  global prtsuf

  set a ""
  set a "${a}[datime] $vv(dta1) \"[lindex [info level [info level]] 0].tcl\" $vv(dta2)\n"

  if {$dirprefix==""} {set mfile $main_file} else {set mfile [stripdir $main_file]} 

  set opt1 "[lindex [split $prtoptions $opsep] 1]";# set driver options (except format)
  if {$printcops!="1"} {set opt1 "$opt1 -c$printcops"};# add number of copies to options
  set opt2 "[lindex [split $prtoptions $opsep] 2]";# set format dependent driver options

  if {$prmsel=="abs" || $prmsel=="odd_abs" || $prmsel=="even_abs"} {

    if {$pg_start=="$vv(dmstart)"} {set start ""} else {set start $pg_start}
    if {$pg_end  =="$vv(dmend)"}   {set ende  ""} else {set ende  $pg_end}

    set incr ""
    if {$prmsel=="odd_abs"}  {set incr "-D1"}
    if {$prmsel=="even_abs"} {set incr "-D2"}

    set opt_seiten ""  
    if {$start!=""} {set opt_seiten "${opt_seiten} -f$start"}
    if {$ende!=""}  {set opt_seiten "${opt_seiten} -t$ende"}

  } else {       # error: unexpected value of $prmsel      

    set a "${a}*** $vv(aerr) (prt_dvilj.tcl): $vv(dt1) $prmsel\n"
    set a "${a}    $vv(adm)\n\n"
    mybell 3; return 1

  }
  
  eval mkCmd_wait $f dvilj [list "$opt1 $opt2 $opt_seiten $mfile -e$prt_file"]

  return 0

}
