# "quick&dirty" TeX run and previewing ($main_file$tsuff (preamble only) with $mouse_grab)
#
# Copyright (C) 1994  G. Lamprecht, W. Lotz, R. Weibezahn; LRW c/o Uni Bremen
# Copyright (C) 1996  G. Lamprecht, W. Lotz, R. Weibezahn; IWD, Bremen University

proc quick {f austext} {

  upvar 1 $austext a

  global vv mouse_grab texmem texfmt main_file tsuff
  global quickfile preamble preamble_found
  global preview prsuffix proptions prback prpreopt quickverbatim quickprereq
  global quickpreform quicksuffix quickpreamble quickendpre quickenddoc


  writescr0 $f ""
  set a ""

  writescr $f "[datime] $vv(qd1)\n$vv(qd2) \"$main_file$tsuff\"\n"

  # look for the preamble
  if {($main_file=="")||(![file exists $main_file$tsuff])} {# main file does'nt exist
    set preamble "$quickpreamble"
  } else {# file exists
    getPreamble $main_file$tsuff
    if {!$preamble_found} {# no preamble identified
      writescr $f "${a}\n$vv(qd9)\n   \"$quickendpre\"\n"
      if {$quickprereq==1} {# preamble requested!
        mybell 4
        writescr $f "$vv(qd10) \"$texfmt\" $vv(qd11)\n"
        writescr $f "$vv(qd12) \"$main_file$tsuff\" $vv(qd13)\n$vv(qd14)\n"
      }
    }
  }

  writescr $f "\n%%%%%%%%%% $vv(qd5) $vv(qd7) %%%%%%%%%%"
  writescr $f "\n$preamble"
  writescr $f "\n%%%%%%%%%% $vv(qd6) $vv(qd7) %%%%%%%%%%"
  writescr $f "\n$quickendpre";                           # writescr $f "\n\begin{document}"
  writescr $f "\n%%%%%%%%%% $vv(qd5) $vv(qd8) %%%%%%%%%%"
  writescr $f "\n$mouse_grab"
  writescr $f "\n%%%%%%%%%% $vv(qd6) $vv(qd8) %%%%%%%%%%"
  writescr $f "\n$quickenddoc\n"

  QuickFileDel; # delete all Quick*Dirty files
  set fd [open $quickfile$quicksuffix w]
  puts $fd "$preamble"
  puts $fd "$quickendpre";                                # puts $fd {\begin{document}}
  puts $fd "$mouse_grab"
  if {($quickverbatim)&&($quickpreform=="latex")} {
    puts $fd {\par\bigskip\normalsize}
    puts $fd {\noindent\hrulefill\ generated by: \hrulefill\begin{verbatim}}
    puts $fd "$preamble\n$quickendpre"; puts $fd {\end{verbatim}}
    puts $fd {\ldots\begin{verbatim}}
    puts $fd "$mouse_grab"; puts $fd {\end{verbatim}}
    puts $fd {\ldots\begin{verbatim}}
    puts $fd "$quickenddoc"; puts $fd {\end{verbatim}}
  }
  puts $fd "$quickenddoc"
  close $fd

  #mkCmd_wait $f $texmem$texfmt [list "\\nonstopmode \\input $quickfile$quicksuffix"]
   mkCmd_wait $f $texmem$texfmt [list "\\input $quickfile$quicksuffix"]

  if ![file exists $quickfile.dvi] {# no dvi file created!
    set a "${a}\n\n***** $vv(pr9) $quickfile$prsuffix $vv(ea4)\n"; mybell 2; return
  }


  # previewing

  writescr $f "[datime] $vv(pr1) $quickfile$prsuffix\n"

  # postscript preview: create postscript file 
  if {$prsuffix==".ps"} {mkCmd_wait $f dvips "$quickfile.dvi $prpreopt -o $quickfile.ps"}

  if [file exists "$quickfile$prsuffix"] {
 
    set a "${a}[datime] $preview $vv(pr7)\n"
 
    set message ""
    signal block SIGCHLD
    eval set res [catch "exec $preview $proptions $quickfile$prsuffix $prback" message]
    signal unblock SIGCHLD

    set a "${a}$message\n";  if {$res!=0} {set a "${a}$vv(pr8)=$res\n"}

  } else {# no file to be previewed!

    set a "${a}\n\n***** $vv(pr9) $quickfile$prsuffix $vv(ea4)\n$vv(pr6)\n"; mybell 2

  }
}
