# Hyperlink-Men fr TeX/LaTeX-Syntax-Help
#
# Copyright (C) 1994  G. Lamprecht, W. Lotz, R. Weibezahn; LRW c/o Uni Bremen
# Copyright (C) 1996  G. Lamprecht, W. Lotz, R. Weibezahn; IWD, Bremen University

proc TeX_syntax_help  {format raise} {# Hypertext version of xtem-syntax-help

proc hlpwin_fill {window filedir entry} {
 global Wh hlp_dir hlp_stack hlp_filedir hlp_bmlist

 if ![winfo exists $window] return

 if {$filedir=="miscellaneous/mainhelp"} {set hlp_stack ""}
 if {$hlp_stack==""} \
      {$Wh.a.2.b configure -state disabled; $Wh.a.2.t configure -state disabled} \
 else {$Wh.a.2.b configure -state normal;   $Wh.a.2.t configure -state normal}
 update
 lvarpush hlp_stack $entry;  lvarpush hlp_stack $filedir
 set c_filedir $filedir
 set c_entry   $entry
 if {"$c_filedir"==""} {set c_filedir "???"}
 if {![file exists "${hlp_dir}${c_filedir}.htx"]} {
   set hlp_filedir $c_filedir
   set c_filedir "miscellaneous/missing_file";  set c_entry "missing_file"
 }
 # remove old tags, clear window etc.
 $window configure -state normal; update
 $window delete 0.0 end; update
 set hlp_bmlist ""; $Wh.a.4.r configure -state disabled; update
 foreach tn [$window tag names] {if {$tn!="sel"} {$window tag delete $tn}}
 $Wh.a.1.e configure -state disabled; update
 hlpwin_fillfile $window "$c_filedir" "$c_entry"
 if {$hlp_bmlist!=""} {$Wh.a.4.r configure -state normal; update}
 $Wh.a.1.e configure -state normal; update
 $window configure -state disabled; update
}

proc hlpwin_bitmap {w filedir} {
 global vv hlp_dir hlp_pid hlp_cbm hlp_wgmdxy hlp_wgmx hlp_bmlist hlp_bmsuppr hlp_thisbm geom

 update

 if {[lsearch $hlp_bmlist $filedir]==-1} {set hlp_bmlist "$hlp_bmlist $filedir "}
 if  {($hlp_bmsuppr)&&(!$hlp_thisbm)} return
 set file [crange $filedir [string last "/" "/$filedir"] end]
 incr hlp_cbm;  set dx [expr 250+20*$hlp_cbm]; set dy [expr 180+20*$hlp_cbm]
 set hlp_wgmdxy +${dx}+${dy}; set hlp_wgmx 600
 set gunzip_not_installed [catch "which gunzip"  m1]

 if {([file exists $hlp_dir${filedir}.xbm]) ||  \
     ([file exists $hlp_dir${filedir}.xbm.gz] && !$gunzip_not_installed)} {# display bitmap

   if {[file exists $hlp_dir${filedir}.xbm.gz]} {# bitmap is packed
     set xbmfile ".xtem_hlpxbm$hlp_cbm";    unlink -nocomplain $xbmfile
     signal block SIGCHLD
     exec gunzip -c $hlp_dir${filedir}.xbm.gz > $xbmfile
     signal unblock SIGCHLD
   } else {
     set xbmfile "$hlp_dir${filedir}.xbm"
   }
   set w .tsxbm$hlp_cbm;    if {[winfo exists $w]} {destros $w}
   toplevel $w;  wm title $w "$vv(tshlp) $file";  wm iconname $w "$file"
   wm minsize $w 15 10
   if [info exists geom($w)] {wm geometry $w $geom($w)} else {wm geometry $w =$hlp_wgmdxy}
   frame     $w.1;  pack $w.1 -anchor nw
   button    $w.1.e -text "$vv(ae)" -command "destros $w"; pack $w.1.e -pady 2 -side left
   label     $w.1.l -text "$vv(tsex)";			   pack $w.1.l -padx 10 -side left
   scrollbar $w.sb -command "$w.bm yview" -relief sunken;  pack $w.sb -side right -fill y
   canvas    $w.bm -yscrollcommand "$w.sb set" -relief raised -borderwidth 1 -width $hlp_wgmx
						pack $w.bm -side left -fill both -expand yes
   $w.bm create bitmap 2 2 -bitmap "@$xbmfile" -anchor nw -tags item
   $w.bm config -scrollregion [$w.bm bbox all]
   if {$xbmfile==".xtem_hlpxbm$hlp_cbm"} {unlink -nocomplain $xbmfile}

 } elseif {[file exists $hlp_dir${filedir}.dvi]} {#bitmap not found, but dvi exists
   set x [expr $hlp_wgmx+100]
   signal block SIGCHLD
   set hlp_pid "$hlp_pid [exec xdvi $hlp_dir${filedir}.dvi \
			-geometry ${x}x400$hlp_wgmdxy -sidemargin 4.0cm -topmargin 4.3cm &]"
   signal unblock SIGCHLD

 } else {# neither bitmap nor dvi exists
   hlpwin_insertinline $w "\n$vv(tsbtm) $hlp_dir$filedir\n" normal
 }
}

proc hlpwin_delbitmaps {} {global hlp_pid hlp_cbm geom

 foreach i [string trim $hlp_pid] {killprocess $i}
 for {set i 1} {$i<=$hlp_cbm} {incr i} {if {[winfo exists .tsxbm$i]} {destros .tsxbm$i}}
 set hlp_pid "";  set hlp_cbm 0

}

proc hlpwin_refreshbitmaps {w} {global hlp_bmlist hlp_thisbm

 hlpwin_delbitmaps
 set hlp_thisbm 1;  foreach i $hlp_bmlist {hlpwin_bitmap $w $i};  set hlp_thisbm 0

}

proc hlpwin_fillAlph {w filedir entry} {# read+analyze an AlphabeticalList.htx, fill into w
 global  vv hlp_dir tsBgr tsFgr hlp_u hlp_line

 set tnr 0
 set fid [open "${hlp_dir}${filedir}.htx" r]
 while {([getscl0 $fid line]!=-1)&&([lindex $line 0]!="@@linktag")} {
   if {[lindex $line 0]=="@title"} \
	{$w insert insert "[crange $line 7 end]\n$hlp_u\n" boldlrge} \
   else {$w insert insert "$line\n" normal}
 }  
 while {([getscl0 $fid line]!=-1)&&([string trim $line]!="@eof")} {
   if {[lindex $line 0]=="@@linktag"} {
     while {[lindex $line 0]!=""} {
	incr tnr
        set tp1 [$w index insert]; set l1 "[lindex $line 1]"
	$w tag bind $tnr <Button-1> "hlpwin_fill $w [lindex "$l1" 1] [lindex "$l1" 2]"
	$w tag bind $tnr <Enter> "$w tag configure $tnr -foreground $tsBgr -background $tsFgr"
	$w tag bind $tnr <Leave> "$w tag configure $tnr -foreground $tsFgr -background $tsBgr"
	$w insert insert [lindex "$l1" 4] [list telesmll $tnr]
	set line [lrange $line 2 end]
     }
     $w insert insert "\n"
   } else {update; # update screen} 
 }  
 close $fid
 return
}

proc hlpwin_fillfile {w filedir entry} {# read+analyze help-file, fill into window w
 global Wh vv hlp_dir hlp_c hlp_cnr hlp_tnr hlp_line hlp_stack hlp_filedir hlp_undline hlp_u

 $w tag configure normal   -font [option get $Wh.normal font text]
 $w tag configure tag      -font [option get $Wh.tag font text]
 $w tag configure italic   -font [option get $Wh.italic font text]
 $w tag configure bold     -font [option get $Wh.bold font text]
 $w tag configure boldlrge -font [option get $Wh.boldlrge font text]
 $w tag configure title    -font [option get $Wh.title font text]
 $w tag configure teletype -font [option get $Wh.teletype font text]
 $w tag configure telelrge -font [option get $Wh.telelrge font text]
 $w tag configure telesmll -font [option get $Wh.telesmll font text]

 set hlp_cnr 0; set hlp_tnr 0; set type normal; set hlp_undline 0; set evaluate 0;
 hlpwin_delbitmaps
 if {[string match "*/Alphabetical_List" "$filedir"]} \
	{hlpwin_fillAlph $w $filedir $entry; return}
 set fid [open "${hlp_dir}${filedir}.htx" r]
 while {([getscl0 $fid line]!=-1)&&([string trim $line]!="@eof")} {
   set l [string trim $line]; set p [string first " " $l]
   if {$p>0} {set first [crange $l 0 $p-1]} else {set first $l}
   set eoltext "\n"; set ctype $type

   if       {$first == "@entries"} {# skip entry line
     set eoltext "";   set hlp_line ""

   } elseif {$first == "@title"} {# prepare title
     set eoltext ""
     set eoltext "${eoltext}\n$hlp_u\n";set ctype boldlrge; set hlp_line [crange $line 7 end]

   } elseif {$first == "@update"} {# update screen
     set eoltext ""; update

   } elseif {$first == "@section"} {# prepare section-title
     set eoltext "\n"; set ctype bold;     set hlp_line [crange $line  9 end]

   } elseif {$first == "@bitmap"} {# prepare bitmap
     set eoltext "";  set hlp_line ""
     set f ""; set p [string last "/" $filedir]; if {$p>=0} {set f "[crange $filedir 0 $p]"}
     hlpwin_bitmap "$w" "$f[crange $line  8 end]";

   } elseif {$first == "@begdescription"} {# prepare description
     set eoltext "\n"; lvarpush typestack $type; set type normal;  set ctype bold
     set hlp_line "$vv(tsdes)"
   } elseif {$first == "@enddescription"} {#
     set eoltext "";   set type [lvarpop typestack]

   } elseif {$first == "@begteletype"} {# prepare teletype
     set eoltext ""; lvarpush typestack $type; set type teletype; set ctype $type
   } elseif {$first == "@endteletype"} {#
     set eoltext "";   set type [lvarpop typestack]

   } elseif {$first == "@begsyntax"} {# prepare syntax description
     set eoltext "\n"; lvarpush typestack $type; set type teletype; set ctype bold
     set hlp_line "$vv(tssyn)"
   } elseif {$first == "@endsyntax"} {#
     set eoltext "";   set type [lvarpop typestack]

   } elseif {$first == "@begexamples"} {# prepare examples      
     set eoltext "\n"; lvarpush typestack $type; set type telesmll; set ctype bold
     set hlp_line "$vv(tsexa)"
   } elseif {$first == "@endexamples"} {#
     set eoltext "";   set type [lvarpop typestack]
     if {[lindex $line 1]!="no_bitmap"} {hlpwin_bitmap "$w" "$filedir"}

   } elseif {$first == "@begeval"} {# starts evaluation of each text-line before output
     set eoltext "";  set evaluate 1
   } elseif {$first == "@endeval"} {# ends   evaluation of each text-line before output
     set eoltext "";  set evaluate 0

   } else {
     set hlp_line $line
   }
   if {$evaluate} {eval set hlp_line "\"$hlp_line\""}
   while {$hlp_line != ""} {hlpwin_insertinline $w [hlpwin_strpart] $ctype}
   $w insert insert "$eoltext";  set eoltext "\n"
   # the following line must be done "in retard" because of an Tk-error (Tcl version 3.6)
   for {set i 1} {$i<=$hlp_cnr} {incr i} {set res [eval $hlp_c($i)]}; # exec tag commands
   set hlp_cnr 0
 }  
 close $fid
}


proc hlpwin_insertinline {w text type} {# fills text t into window w with font type
 global Wh hlp_line  hlp_c hlp_cnr hlp_tnr hlp_bdw hlp_undline tsFgr tsBgr

 set pf [string first "@@" $text];# look for inline-command
 if {$pf<0} {# "text" contains no inline-command
   set tp1 [$w index insert]; $w insert insert "$text"; set tp2 [$w index insert]
   if {$hlp_undline} {
     $w tag configure underline -font [option get $Wh.$type font text] -underline on;
     set type underline
   }
   incr hlp_cnr; set hlp_c($hlp_cnr) "$w tag add $type $tp1 $tp2"
 } elseif {$pf>0} {# "text" starts with normal text, followed by inline-command
   set string [crange $text 0 $pf-1]
   set tp1 [$w index insert]; $w insert insert "$string"; set tp2 [$w index insert]
   incr hlp_cnr; set hlp_c($hlp_cnr) "$w tag add $type $tp1 $tp2"
   hlpwin_insertinline $w [crange $text $pf end] $type
 } else           {# "text" starts with inline-command
   set com  [lindex $text 0];   set l [string length $com]
   set text [string trimleft [crange $text $l+1 end]]
   set arg  [lindex $text 0];   set l [string length $arg]
   if {[string first "\{" $text]==0} {set rest [crange $text $l+3 end]} \
   else {set rest [crange $text $l+1 end]}
   if {$com=="@@linktag"} {# prepare LinkTag
     set hlp_bdw 1; set hlp_undline 0
     if {[regsub "@@bdw" $arg "" arg]} {
	set hlp_bdw [string index $arg 0]; set arg [crange $arg 2 end]
	if {$hlp_bdw=="_"} {set hlp_bdw 0; set hlp_undline 1}
     }
     set arg  [string trimleft $arg]
     set tdir [lindex "$arg" 0];   set l [string length $tdir]
     set arg  [string trimleft [crange $arg $l+1 end]]
     set tent [list [lindex "$arg" 0]];   set l [string length $tent]
     set t    [crange "$arg" $l+1 end]
     if {[string first "\{" $t]==0} {set t [lindex $t 0]} else {set t [crange $t 0 end]}
     set tp1 [$w index insert];  hlpwin_insertinline $w "$t" tag;  set tp2 [$w index insert]
     incr hlp_tnr 
     incr hlp_cnr; set hlp_c($hlp_cnr) \
	"$w tag configure $hlp_tnr -relief raised -borderwidth $hlp_bdw -background $tsBgr"
     incr hlp_cnr; set hlp_c($hlp_cnr) "$w tag add $hlp_tnr $tp1 $tp2"
     incr hlp_cnr; set hlp_c($hlp_cnr) \
	"$w tag bind $hlp_tnr <Button-1> \"hlpwin_fill $w $tdir $tent\""
     incr hlp_cnr; set hlp_c($hlp_cnr) \
	"$w tag bind $hlp_tnr <Leave> \"$w tag configure $hlp_tnr -foreground $tsFgr \
								  -background $tsBgr\""
     incr hlp_cnr; set hlp_c($hlp_cnr) \
	"$w tag bind $hlp_tnr <Enter> \"$w tag configure $hlp_tnr -foreground $tsBgr \
								  -background $tsFgr\""
     set hlp_undline 0
   } elseif {($com=="@@tt") || ($com=="@@ts") || ($com=="@@tl") || ($com=="@@em") || \
	     ($com=="@@bf") || ($com=="@@bl") || ($com=="@@rm")} {
		if     {$com=="@@tt"}   {set ctype teletype} \
		elseif {$com=="@@tl"}   {set ctype telelrge} \
		elseif {$com=="@@ts"}   {set ctype telesmll} \
		elseif {$com=="@@em"}   {set ctype italic} \
		elseif {$com=="@@bf"}   {set ctype bold} \
		elseif {$com=="@@bl"}   {set ctype boldlrge} \
		elseif {$com=="@@rm"}   {set ctype normal} \
		else                    {set ctype normal}
     hlpwin_insertinline $w "$arg" $ctype
   } else {# is not an implemented inline-command!
     puts stdout "*** xtem-Error (ts.tcl): inline-command \"$com\" not implemented!"; 
     flush stdout; mybell 4
   }
   if {$rest!=""} { hlpwin_insertinline $w "$rest" $type}
 }
}


proc hlpwin_strpart {} {# returns next part of "hlp_line":
#                            pure text up to next inline-command        or
#                            inline-command together with its argument
 global hlp_line

 set pf [string first "@@" "$hlp_line"]
 if {$pf<0} {# no inline-command
   set strpart $hlp_line; set hlp_line ""
 } elseif {$pf==0} {# starts with inline command
   # gives the command, deletes it from "hlp_line"
     set strpart [lindex $hlp_line 0]; set l [string length $strpart]
     set hlp_line [crange $hlp_line $l+1 end]
   # cut first list element from "hlp_line" and gives its content
   # first (separating) blank after listelement is deleted!
     set hlp_line [string trim $hlp_line]
     set listel [lrange $hlp_line 0 0];   set l [string length $listel]
     set hlp_line [crange $hlp_line $l+1 end]
     set strpart "$strpart $listel"
 } else   {# $pf>0 --> starts with pure text, followed by inline-command
   set strpart [crange $hlp_line 0 $pf-1]
   set hlp_line [crange $hlp_line $pf end]
 }
 return $strpart
}


global vv Wh geom edsyntaxhelp tssk edsyntaxchg hlp_u hlpWin
global hlp_dir hlp_stack hlp_width tsFgr tsBgr hlp_pid hlp_cbm hlp_bmsuppr hlp_thisbm


if [winfo exists $Wh] {
 if {$raise} {
   if {[wm state $Wh]=="normal"} {raise $Wh} else {wm deiconify $Wh}
 } else {
   if {$edsyntaxchg} {
	if {([wm state $Wh]=="normal")&&($edsyntaxhelp==$tssk(1))} {raise $Wh}
	if {([wm state $Wh]=="normal")&&($edsyntaxhelp==$tssk(2))} {wm iconify $Wh}
	if {([wm state $Wh]=="iconic")&&($edsyntaxhelp==$tssk(1))} {wm deiconify $Wh}
	if {($edsyntaxhelp==$tssk(3))} {wm destroy $Wh}
   }
 }
 set edsyntaxchg 0
 return
}
if {($edsyntaxhelp==$tssk(3))&&(!$raise)} {return}


toplevel $Wh;  wm title $Wh "$vv(tsvor)";  wm minsize $Wh 15 10
if {($edsyntaxhelp=="$tssk(2)")&&(!$raise)} {wm iconify $Wh}
if [info exists geom($Wh)] {wm geometry $Wh $geom($Wh)}

set hlp_pid ""; set hlp_cbm 0; set edsyntaxchg 0; set hlpWin $Wh.li.t


label $Wh.normal; label $Wh.tag; label $Wh.italic; label $Wh.bold; label $Wh.boldlrge
label $Wh.title; label $Wh.teletype; label $Wh.telelrge; label $Wh.telesmll

# top buttons

frame $Wh.a -relief raised -borderwidth 1; pack configure $Wh.a -pady 2 -anchor w

frame $Wh.a.1; frame $Wh.a.2; frame $Wh.a.3 -borderwidth 2; frame $Wh.a.4
pack configure $Wh.a.1 $Wh.a.2 $Wh.a.3 $Wh.a.4 -pady 2 -side left -anchor n

button $Wh.a.1.e -text "$vv(ae)" -command {destros $Wh; hlpwin_delbitmaps; set texfmtts ""}
Bind3P $Wh.a.1.e 1 hlpwin_fill $hlpWin miscellaneous/w_end end
pack configure $Wh.a.1.e -side left -padx 5 -pady 3

button $Wh.a.2.t -text "$vv(tsat)" -command \
	{global hlpWin; hlpwin_fill $hlpWin "miscellaneous/mainhelp" "mainhelp"}
Bind3P $Wh.a.2.t 1 hlpwin_fill $hlpWin miscellaneous/w_top top
button $Wh.a.2.b -text "$vv(tsab)" -command {
  lvarpop hlp_stack;  lvarpop hlp_stack; global hlpWin
  set filedir [lvarpop hlp_stack]; set entry [lvarpop hlp_stack]
  if {($filedir!="")&&($entry!="")} {hlpwin_fill $hlpWin "$filedir" "$entry"}
}
Bind3P $Wh.a.2.b 1 hlpwin_fill $hlpWin miscellaneous/w_back back
pack configure $Wh.a.2.t $Wh.a.2.b -side top -anchor w -padx 5 -pady 3

set hlp_thisbm 0
frame $Wh.a.3.bm -relief raised -borderwidth 2
pack configure $Wh.a.3.bm -side top -anchor w -padx 5 -pady 0
checkbutton $Wh.a.3.bm.i -borderwidth 2 -variable hlp_bmsuppr -text "$vv(tsbm)" -command {
 global hlp_bmsuppr; if {$hlp_bmsuppr} {hlpwin_delbitmaps} {hlpwin_refreshbitmaps $hlpWin}
}
Bind3P $Wh.a.3.bm.i 1 hlpwin_fill $hlpWin miscellaneous/w_bitmap bitmap
pack configure $Wh.a.3.bm.i -side top -anchor w -padx 5 -pady 3

button $Wh.a.4.r -text "$vv(tsbmr)" -command {hlpwin_refreshbitmaps $hlpWin}
Bind3P $Wh.a.4.r 1 hlpwin_fill $hlpWin miscellaneous/w_bitmap_r refresh
pack configure $Wh.a.4.r -side top -anchor w -padx 5 -pady 3

if {![info exists hlp_width]} {set hlp_width 80 }
scrollbar $Wh.sb -command "$Wh.li.t yview" -relief sunken
Bind3P $Wh.sb 1 hlpwin_fill $hlpWin miscellaneous/w_text text
frame $Wh.li -relief raised -borderwidth 1 
text $Wh.li.t -yscrollcommand "$Wh.sb set" -width $hlp_width -height 32 \
		-padx 3 -pady 2
Bind3P $Wh.li.t 1 hlpwin_fill $hlpWin miscellaneous/w_text text
pack $Wh.sb -side left -fill y
pack $Wh.li $Wh.li.t -side right -fill both -expand yes
set tsFgr [lindex [$hlpWin configure -foreground] 4]
set tsBgr [lindex [$hlpWin configure -background] 4]

set hlp_u "___________________________________________________________________"

hlpwin_fill $hlpWin "miscellaneous/mainhelp" "mainhelp"
}
