# Allgemeine Prozeduren fr xtem_texmenu
#
# Copyright (C) 1994  G. Lamprecht, W. Lotz, R. Weibezahn; LRW c/o Uni Bremen
# Copyright (C) 1996  G. Lamprecht, W. Lotz, R. Weibezahn; IWD, Bremen University


proc decr {v} {upvar 1 $v n; incr n -1}; # decrement v by -1


proc datime {} {return [fmtclock [getclock] +%H:%M:%S]; # liefert Uhrzeit als Return-Wert!}


proc cat_file {dnam f} {# Anlisten der Datei dnam im Fenster f
#
  global vv
  $f configure -state normal
  set fid [open "$dnam" r]; $f insert end "[read $fid]@\n"; close $fid
  $f configure -state disabled
} 


proc cat_file0 {file w} {# Anlisten der Datei file im Fenster w
#			   nach vorherigem Lschen des bisherigen Fensterinhalts
  global anl0 vv
  set fid [open "$file" r]
  if {($anl0==1)&&($w==".d.tt")} {# Anlisten "mit Vorsicht" (derzeit luft ein Programm)
    $w insert end "\n\n***** $vv(ut1)\n[read $fid]\n***** $vv(ut2)\n\n"
  } else {# Anlisten normal, es luft derzeit kein Programm
    $w configure -state normal
    $w delete 0.0 end;  $w insert end "[read $fid]@\n";  $w yview 0
    $w configure -state disabled
  }
  close $fid
} 


proc Bind2HF    {W      file w} {BindnHTF 2 $W \"\"      $file $w};### Help-bindings: Button-2
proc Bind3HF    {W      file w} {BindnHTF 3 $W \"\"      $file $w};### Help-bindings: Button-3
proc Bind3HTF   {W text file w} {BindnHTF 3 $W \"$text\" $file $w};### Help-bindings: Button-3
proc BindnHTF {n W text file w} {   ### bindings for help text and file via Button-2, Button-3
 # -relief sunken/raised critical with "label": if clicked during program run/see variable sub
 # bind $W <ButtonPress-$n> "$W configure -relief sunken; pack $W; Bend"
 # bind $W <ButtonPress-$n><ButtonRelease-$n> \
 #	"$W configure -relief raised; pack $W;HTxtFile0 $text $file $w; Bend"
 # bind $W <ButtonPress-$n><Leave> "$W configure -relief raised; pack $W; Bend"
 # bind $W <ButtonPress-$n><Leave><ButtonRelease-$n> \
 #	 "$W configure -relief raised; pack $W; Bend"
 ## thus:
  bind $W <ButtonPress-$n>                                 "Bend"
  bind $W <ButtonPress-$n><ButtonRelease-$n>               "HTxtFile0 $text $file $w; Bend"
  bind $W <ButtonPress-$n><Leave><ButtonRelease-$n>        "Bend"
  bind $W <ButtonPress-$n><Leave><Enter><ButtonRelease-$n> "HTxtFile0 $text $file $w; Bend"
}
proc HTxtFile0 {text file w} {
 global sub hlp_dir RequestActive
 if {($sub>0)&&($w==".d.tt")&&($RequestActive!=1)} {return}
 writescr0 $w $text; cat_file $hlp_dir$file.hlp $w
}

proc Bind2P   {W ExAllow proc args} {BindnP 2 $W $ExAllow $proc $args};### exec proc: Button-2
proc Bind3P   {W ExAllow proc args} {BindnP 3 $W $ExAllow $proc $args};### exec proc: Button-3
proc BindnP {n W ExAllow proc args} {   ### bindings for procedure call via Button-2, Button-3
 # -relief sunken/raised critical with "label": if clicked during program run/see variable sub
 #bind $W <Button-$n> "ProcExec $ExAllow $proc $args"
  bind $W <ButtonPress-$n>                          "Bend"
  bind $W <ButtonPress-$n><ButtonRelease-$n>        "ProcExec $ExAllow $proc $args; Bend"
  bind $W <ButtonPress-$n><Leave><ButtonRelease-$n> "Bend"
  bind $W <ButtonPress-$n><Enter><ButtonRelease-$n> "ProcExec $ExAllow $proc $args; Bend"
}
proc ProcExec {ExAllow proc args} {
 global sub
 TestPut 3 "<$sub><$ExAllow>  <$proc> <$args>"
 if {($sub>0)&&($ExAllow==0)} {return};# when other program runs: exec proc only if allowed
 eval $proc [join $args]
}

proc LeftMouseOnly {w} {global vv; writescr0 $w "$vv(xt25)\n"; mybell 1}

proc CallSetMenu {p} {lock; set sub 1; $p}


proc clearscr {w} {$w configure -state normal;$w delete 0.0 end;$w configure -state disabled}


proc mybell {level} {global bell_level; if {$level>=$bell_level} {bell}; # significant signal}
####                        bell_level: 1=no_restriction/2=warnings+errors/3=errors/4=no_bell
#### use   mybell 1    for low level messages
#### use   mybell 2    for warnings
#### use   mybell 3    for errors
#### use   mybell 4    for very hard errors: must bell in any case


proc testfilename {fname win suf} {# test filename (only letters, numerals, some others)
  global vv
  set f $fname
  if {$f==""} {mybell 2;  writescr $win "$vv(ut3)\n"; $win yview 0; return 1}
  
  if {[regexp {^[/a-zA-Z0-9_-]+$} $f]&&![regexp {^[-].*$} $f]} {return 0} 
  mybell 2
  set r 1
  writescr $win "$vv(ut4) \"$f\" $vv(ut5)\n         $vv(ut6)"
  if {$suf!=""} {writescr $win "$vv(ut7) \"$suf\""}
  writescr $win "\n"
  if {[string match "* *" $f]} {writescr $win "\n***** $vv(ut8)\n"; mybell 3; set r 2} 
  if {[regexp {^[-].*$} $f]} {writescr $win "\n***** $vv(ut9)\n"; mybell 3} 
  $win yview 0; return $r
}


proc mtest {str var} {# Looks for the Variable $var in the personal .vst-files;
#                       if found: sets it to the assigned value
  upvar 1 $var v
  set pat $var
  if {[string match "$pat*" [string trim $str]]} {
	set z "[string trim $str] "; set p [string first " " $z]
	set v [string trim [string range $z $p end]] 
  }
}


proc progback {prog back} {# Testen, ob Programm $prog im Hintergrund 
#                            aufgerufen werden soll,
#                            Setzen von $back und korrigieren von $prog
  upvar 1 $prog programm
  upvar 1 $back background

  set bpos [string last & "$programm"]
  if {$bpos>0} {
    set programm [string trim [string range $programm 0 [expr {$bpos - 1}]]]
    set background & 
  } else {
    set background ""
  }
  set $programm [string trim $programm]
}


proc writescr {w args} {# Ausgabe einer variablen Anzahl von Strings 
#                        (aus $args) im Textfenster $w
  $w configure -state normal
  foreach i $args {$w insert end "$i"}
  $w yview -pickplace end
  $w configure -state disabled
  update idletasks
} 


proc writescr0 {w args} {# Ausgabe einer variablen Anzahl von Strings 
#                         (aus $args) im Textfenster $w
#			  nach vorherigem Lschen des bisherigen Fensterinhalts
  $w configure -state normal
  $w delete 0.0 end
  foreach i $args {$w insert end "$i"}
  $w yview -pickplace end
  $w configure -state disabled
  update idletasks
} 


proc writescr2 {w args} {# Ausgabe einer variablen Anzahl von Strings ohne update
#                        (aus $args) im Textfenster $w
  $w configure -state normal
  foreach i $args {$w insert end "$i"}
  $w yview -pickplace end
  $w configure -state disabled
} 


proc getscl {foid e} {# filter for call of gets, but line breaks by "\" allowed
#
  upvar 1 $e ein

  set ret [gets $foid z];  set z [string trimright $z]
  set ein "$z"
  set lm1 [expr [string length $z]-1]
  while {($lm1>=0)&&([string last \\ $z]==$lm1)} { 
    set ein [string range $ein 0 [expr [string length $ein]-2]]
    set ret [gets $foid z];  set z [string trimright $z]
    set lm1 [expr [string length $z]-1]
    set ein "$ein$z"
  }
  if {$ret>=0} {set ret [string length "$ein"]};  return $ret
}


proc getscl0 {foid e} {# like getscl, but blanks at begin-of-continuation-line deleted
#                
  upvar 1 $e ein

  set ret [gets $foid z];  set z [string trimright $z]
  set ein "$z"
  set lm1 [expr [string length $z]-1]
  while {($lm1>=0)&&([string last \\ $z]==$lm1)} { 
    set ein [string range $ein 0 [expr [string length $ein]-2]]
    set ret [gets $foid z];  set z [string trimright $z]
    set lm1 [expr [string length $z]-1]
    set ein "$ein[string trimleft $z]"
  }
  if {$ret>=0} {set ret [string length "$ein"]};  return $ret
}


proc fillbox {w dat} {# fill listbox $w from .vst-file $dat, if file exists
#
  if {$dat!=""} {set f [open_vst $dat]; while {[getscl $f e]>0} {$w insert end $e}; close $f}
}


proc fillboxsep {w dat} {# listbox $w fllen aus .vst-Datei $dat und Separator
#                                     bestimmen (1. Zeichen ungleich Blank)
  set f [open_vst $dat]
  getscl $f e;  set sep [string index [string trim $e] 0]
  while {[getscl $f e]>0} {$w insert end $e}
  close $f
  return $sep
}


proc TestNotEmpty {string message} {# write message if string empty and exit
 if {$string!=""} return
 global Werr;  set Werr .xtemerror
 mybell 4;  puts stdout "\n$message\n"; flush stdout
 toplevel_init $Werr abc 0 0
 button $Werr.l -text "$message --> exit" -command {destroy $Werr; exit} -height 20
 pack configure $Werr.l; after 2000 raise $Werr
}


proc GetSep {d f} {# read separator for vst-file (read separator line only)
 global vv
 getscl $f e; set s [string index [string trim $e] 0]
 TestNotEmpty "$s" "Error in file $d (empty first line!)\n$vv(adm)"
 return $s
}


proc getsep {d} {# get separator for vst-file $d (open, read-separator, close)
 set f [open_vst $d]; set s [GetSep $d $f]; close $f
 return $s
}


proc getlnum {d} {# get number of lines in file $d (open, read-lines, close)
  set f [open_vst $d]; set n 0; while {[getscl $f e]>0} {incr n}; close $f; return $n
}


proc alternative {dv t1 t2} {# Hilfsprozedur fr alternative Ausgabe 
#
  if {$dv==""} {return $t1} else {return $t2}
}


proc stripdir {file} {return [crange $file [string last / $file]+1 end];# strip dir from file}


proc Request {t text1 text2 textY comY textN comN helpdatei w} {# 2 reply buttons: yes/no
  global  vv hlp_dir geom RequestActive
  TestPut 3 "<$t><$text1><$text2>< $textY><$comY> <$textN><$comN> <$helpdatei><$w>"
  set w "$w.d.tt"
  wm title $t "$vv(utvor)"
  if [info exists geom(ut_rp)] {wm geometry $t $geom(ut_rp)}
  label $t.text1 -text "$text1"; pack configure $t.text1 -padx 37 -pady 13
  set RequestActive 1
  if {$text2!=""} {label $t.text2 -text "$text2"; pack configure $t.text2 -padx 37 -pady 13}
  frame $t.r -relief raised -borderwidth 0; pack configure $t.r -pady 16
  button $t.r.yes -text "$textY" -command "$comY; set RequestActive 0"
  button $t.r.no  -text "$textN" -command "$comN; set RequestActive 0"
  pack configure $t.r.yes $t.r.no  -side left -padx 13
  if {$helpdatei!=""} {
    Bind3HF $t $helpdatei $w
    Bind3HF $t.text1 $helpdatei $w; if {$text2!=""} {Bind3HF $t.text2 $helpdatei $w}
    Bind3HF $t.r.yes $helpdatei $w; Bind3HF $t.r.no  $helpdatei $w
  }
}


proc destror w {global geom
  set g [wm geometry $w]; set geom(ut_rp) [crange $g [string first + $g] end]
  destroy $w; update
}

proc destros w {global geom; set geom($w) [wm geometry $w];  destroy $w; update}

proc toplevel_init {w wname wmin wmax} {global geom; # initialisations for toplevel window

  if [winfo exists $w] {destros $w};  toplevel $w;  wm title $w $wname
  wm minsize $w $wmin $wmax;  if [info exists geom($w)] {wm geometry $w $geom($w)}
}


proc mdtest {hd stex sdvi aus} {# Test, welche von zwei Dateien $hd$stex / $hd$sdvi lter ist
#                                  ( $hd$sdvi sollte neuere Datei sein!)
 upvar 1 $aus a
 global vv
 if {$hd==""}               {mybell 2;set a "\n***** $vv(ea1)\n"; return -1}
 if ![file exists $hd$sdvi] {mybell 2;set a "\n*** $vv(ut10) $hd$sdvi $vv(ut100)\n";return -1}
 if ![file exists $hd$stex] {mybell 2;set a "$vv(ut11) $hd$stex $vv(ut12)\n"; return 1}
 set t1 [file mtime $hd$stex]
 set t2 [file mtime $hd$sdvi]
 if {$t1>$t2} {mybell 2; set a "$vv(ut11) $hd$stex $vv(ut13) $hd$sdvi $vv(ut14)\n"; return 0}
 return 1
}


proc getvalue {zeile n separator} {# aus der Zeile den n-ten Wert zurckgeben

  set tmp $zeile
  set count 0
  while {$count<$n} {
    set pos [string first $separator $tmp]
    if {$pos>=0} {set tmp [string range $tmp [expr $pos+1] end]} else {set tmp ""}
    incr count
  }

  set pos [string first $separator $tmp]
  if {$pos>=0} {set tmp [string range $tmp 0 [expr $pos-1]]}
  incr count
  return [string trim $tmp]
}


proc checksum {} {# Ermittlung der Prfsumme fr die .aux-Dateien
# 
  global sub
  set prsum 0
  foreach i [glob -nocomplain -- *] {
    if {[file isfile $i]&&[string match "*.aux" $i]} {
      if {[file size $i]>0} {
	##############################
	# One of the following alternatives must be chosen for checksum:
	# a) checksum in pure Tcl (simple test only!)
	#   set prsumd [checksum_file $i]
	# b) checksum with Unix command (System V and UCB)
	    signal block SIGCHLD
	    set prsumd [string trim [lindex [exec sum $i] 0]]
	    signal unblock SIGCHLD
            lock; set sub 1;
	    set prsumd [string trimleft $prsumd 0]
	##############################
      } else {
	set prsumd 0
      }
      incr prsum $prsumd
    }
  }
  return $prsum
}


proc checksum_file {datei} {# checksum in pure Tcl
#
  set fileid [open $datei r]
  set filesize [file size $datei]
  if {$filesize==0} {# Datei hat Lnge 0
    close $fileid; return 0
  } else {# Datei hat Lnge > 0
    set chars "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"
    set chars "${chars}1234567890.':<>|`~!@#%^&*()-_=+\[\]\$\ \;\"\{\}\\\n\b"
    set prs 0
    set bytegel 0
    set faktor 1
    while {"$bytegel"<"$filesize"} {
      set byte [read $fileid 1]; incr bytegel
      set prs [expr "$prs+([string first $byte $chars]*$faktor)"]
      if {$faktor==1} {set faktor 2} else {set faktor 1}
    }
    close $fileid; return $prs
  }
}

proc vstr_readinst1 {varname} {global $varname
 if {[info exists env(XTEMINSTALL)]} {set f [open "$env(XTEMINSTALL)" r]} \
 else				     {set f [open_vst install.vst]}
 while {[getscl $f z]>0} {set [lindex $z 0 ] [lindex $z 1]}
 close $f
}

proc vstr_exec {exit} {
 global vv mkcommand xvcsel_v xvbsel_v bell_level xvsbsel_v textxscroll xtemTyh xvTyh Wx
 global XiInstallationRuns
 set f [open_vst mkcommand.vst]; set s [GetSep mkcommand.vst $f]; set m ""
 while {$m==""} {getscl $f e;  set m [getvalue $e [MkcmdTclVCol $exit] $s]}
 close $f
 set mkcommand $m
 set xvcsel_v "[crange [getvalue $e [MkcmdTclVCol exit] $s]  0 10] :  [getvalue $e 0 $s]"
 vstr_readinst1 fsmenucols
 vstr_readinst1 bell_level;  set xvbsel_v "$vv(xveb$bell_level)"
 vstr_readinst1 textxscroll;  set xvsbsel_v "$vv(xvesb$textxscroll)"
 if {[winfo exists .d]&&![info exists XiInstallationRuns]} \
	{destroy .d; InsertTextFrame "" $xtemTyh}
 if {[winfo exists $Wx.d]} {destroy $Wx.d; InsertTextFrame $Wx $xvTyh}
}

proc vstr_editor {} {
 global We editor edtext esuff edxterm edoptions evesel_v
 set f [open_vst editor.vst]; set s [GetSep editor.vst $f]; getscl $f e; close $f
 set evesel_v "$e"; set edtext [getvalue $e 0 $s]
 set edxterm   [getvalue $e 1 $s]; set editor [getvalue $e 2 $s]
 set edoptions [getvalue $e 3 $s]
 vstr_readinst1 edsyntaxhelp
 if [winfo exists $We.c.f.f.li] {selection clear $We.c.f.f.li}
}

proc vstr_tex {} {
 global Wt texfmt texfmtt texmem texmtext texmax texmaxdef tvfsel_v tvssel_v tvmsel_v
 global texloganalyze texlogatext texlogopts tvLSel_v tlOverfull tlOfull tlHBadness tlHBad
 global tlMaxL tlMaxLines quickenable quickverbatim quickprereq quickpreform
 global quicksuffix quickpreamble quickendpre quickenddoc
 set f [open_vst texfmt.vst]; set s [GetSep texfmt.vst $f]; getscl $f e; close $f
 set tvfsel_v "$e"; set texfmtt [getvalue $e 0 $s]; set texfmt [getvalue $e 1 $s]
 set quickenable [getvalue $e 2 $s]; set quickverbatim [getvalue $e 3 $s]
 set quickprereq [getvalue $e 4 $s]; set quickpreform [getvalue $e 5 $s]
 set quicksuffix [getvalue $e 6 $s]; set quickpreamble [getvalue $e 7 $s]
 set quickendpre [getvalue $e 8 $s]; set quickenddoc [getvalue $e 9 $s]
 if {$quickenable==""} {set quickenable 0}
 set f [open_vst texsiz.vst]; set s [GetSep texsiz.vst $f]; getscl $f e; close $f
 set tvssel_v "$e"; set texmtext [getvalue $e 0 $s]; set texmem [getvalue $e 1 $s]
 set texmax $texmaxdef; set tvmsel_v $texmax
 set f [open_vst loganalyze.vst]; set s [GetSep loganalyze.vst $f]; getscl $f e; close $f
 set tvLSel_v "$e"; set texlogatext [getvalue $e 0 $s]
 set texloganalyze [getvalue $e 1 $s]; set texlogopts [getvalue $e 2 $s]
 set tlOfull $tlOverfull; set tlHBad $tlHBadness; set tlMaxL $tlMaxLines
 if [winfo exists $Wt.c.f.f.f.li] {selection clear $Wt.c.f.f.f.li}
 if [winfo exists $Wt.c.s.f.f.li] {selection clear $Wt.c.s.f.f.li}
 if [winfo exists $Wt.c.m.f.f.li] {selection clear $Wt.c.m.f.f.li}
 if [winfo exists $Wt.c.l.f.f.li] {selection clear $Wt.c.l.f.f.li}
}

proc vstr_preview {} {
 global Wp vst_dir prtext preview prsuffix proptions prformat prpreopt
 set f [open_vst preview.vst]; set s [GetSep preview.vst $f]; getscl $f e;
 set z [split $e $s]; set prtext   [string trim [lindex $z 0]]
 set preview   [string trim [lindex $z 1]]; set prsuffix [string trim [lindex $z 2]]
 set proptions [string trim [lindex $z 3]]
 set fl [string trim [lindex $z 4]];set p1 [string first \{ $fl];set p2 [string first \} $fl]
 set prformat [string trim [crange $fl 0 $p1-1]]
 if {[expr $p1+1]<$p2} {set prpreopt [string trim [crange $fl $p1+1 $p2-1]]} {set prpreopt ""}
 set fl [crange $fl $p2+1 end];    set p1 [string first \{ $fl]; set p2 [string first \} $fl]
 if {[expr $p1+1]<$p2} {set proptions "$proptions [string trim [crange $fl $p1+1 $p2-1]]"}
 while {$e!=""} {
   if {[string trim [lindex $z 4]]==""} {
     puts stdout "Error in file $vst_dir/preview.vst - empty format string in line:\n $e"
     mybell 3
   }
   getscl $f e; set z [split $e $s]
 }
 close $f
 if [winfo exists $Wp.c.1.f.f.li] {selection clear $Wp.c.1.f.f.li}
 if [winfo exists $Wp.c.2.f.f.li] {selection clear $Wp.c.2.f.f.li}
}

proc vstr_logfile {} {
 global Wl logtext logform logxterm logoptions lsuff lvfsel_v lvssel_v
 set f [open_vst logform.vst]; set s [GetSep logform.vst $f]; getscl $f e; close $f
 set lvfsel_v "$e"; set logtext [getvalue $e 0 $s]
 set logxterm   [getvalue $e 1 $s]; set logform [getvalue $e 2 $s]
 set logoptions [getvalue $e 3 $s]
 set f [open_vst logsuffix.vst]; getscl $f e; close $f; set lvssel_v "$e";
 set lsuff [getvalue $e 0 " "]
 if {($logform=="tl")&&($lsuff!=".log")} {set lsuff ".log"}
 if [winfo exists $Wl.c.1.f.f.li] {selection clear $Wl.c.1.f.f.li}
 if [winfo exists $Wl.c.2.f.f.li] {selection clear $Wl.c.2.f.f.li}
}

proc vstr_cleanup {} {
 global aufmax aufsuff auftoggle
 set f [open_vst cleanup.vst]; set s [GetSep cleanup.vst $f]
 set aufsuff ""; set auftoggle ""
 while {[getscl $f e]>0} \
   {set aufsuff "$aufsuff [getvalue $e 0 $s]"; set auftoggle "$auftoggle [getvalue $e 1 $s]"}
 close $f
}

proc vstr_printer {} {
 global vv vst_dir printer lpcmd lpopt prtpresel prtselstr
 global prtoptions prtsuf prtfilperm prtformat prtdriver
 set f [open_vst printing.vst]; getscl $f e; set s [string index [string trim $e] 0]
 TestNotEmpty "$s" "Error in file printing.vst (empty first line!)\n$vv(adm)"
 set drselmax 2; while {[getvalue $e [expr $drselmax+9] $s] != ""} {incr drselmax}
 getscl $f e; set z [split $e $s]
 if {[string trim [lindex $z 0]]==""} {# first argument is empty: pre-selection settings
   set prtpresel [string trim [lindex $z 1]]
   if {([string trim [lindex $z 2]]=="*")||([string trim [lindex $z 2]]=="")|| \
       ([string trim [lindex $z 3]]=="*")||([string trim [lindex $z 3]]=="")} \
	{set prtpresel "$prtpresel *"} \
   else {set prtpresel "$prtpresel [string trim [lindex $z 2]]:[string trim [lindex $z 3]]"}
   for {set i 2} {$i<=$drselmax} {incr i} \
	{set prtpresel "$prtpresel [string trim [lindex $z [expr $i+9]]]"}
   getscl $f e; set z [split $e $s]
 } else {# 1 argument not empty: printer setting line
   for {set i 1; set prtpresel "*"} {$i<=$drselmax} {incr i} {set prtpresel "$prtpresel *"}
 }
 set prtselstr "[string trim [lindex $z 0]], [string trim [lindex $z 1]]"
 set prtselstr "$prtselstr, [string trim [lindex $z 2]]:[string trim [lindex $z 3]]"
 set l [string trim [lindex $z 11]]; set p [string first \{ $l]
 if {$p<=0} {TestNotEmpty "" \
	"Error in file printing.vst (empty 2nd or 3rd line?!)\n$vv(adm)"}
 set prtselstr "$prtselstr, [string trim [crange $l 0 $p-1]]"
 set prtformat [string trim [crange $l 0 $p-1]]
 for {set i 4} {$i<=$drselmax} {incr i} {
   set l [string trim [lindex $z [expr $i+8]]]; set p [string first \{ $l]
   if {$p>0} {set prtselstr "$prtselstr, [string trim [crange $l 0 $p-1]]"} \
   else {set prtselstr "$prtselstr, [string trim $l]"}
 }
 prt_select "$prtselstr" ""
 while {$e!=""} {
   if {[string trim [lindex $z [expr $drselmax+8]]]==""} {
     puts stdout "Error in file $vst_dir/printing.vst - empty last criterion in line:\n $e"
     mybell 3
   }
   getscl $f e; set z [split $e $s]
 }
 close $f
 vstr_driver
}
proc vstr_driver {} {
 global Wdm Wdv prtdriver dmdsel_v prmtext prmrelabs prmsel prtreversed
 set f [open_vst prt_$prtdriver.vst]; set s [GetSep prt_$prtdriver.vst $f]
 getscl $f e; close $f; set z [split $e $s]; set dmdsel_v "$e"
 set prmtext [string trim [lindex $z 0]]; set prmrelabs [string trim  [lindex $z 1]]
 set prmsel [string trim [lindex $z 2]]; set prtreversed [string trim [lindex $z 3]]
 if [winfo exists $Wdm.b.f.f.li] {selection clear $Wdm.b.f.f.li}
 if [winfo exists $Wdv.c.f.f.li] {selection clear $Wdv.c.f.f.li}
}

proc vstr_spell {} {
 global Wr sptext spcmd splang spcorr spselect spoptions rvsel_v
 set f [open_vst spellcheck.vst]; set s [GetSep spellcheck.vst $f]; getscl $f e; close $f
 set rvsel_v "$e"; set sptext [getvalue $e 0 $s]
 set spcmd [getvalue $e 1 $s];  set splang [getvalue $e 2 $s]
 set spcorr [getvalue $e 3 $s]; set spselect [getvalue $e 4 $s]
 set spoptions [getvalue $e 5 $s]
 if [winfo exists $Wr.c.f.f.li] {selection clear $Wr.c.f.f.li}
}

proc vstr_index {} {
 global Wi intext index inoptions ivsel_v
 set f [open_vst index.vst]; set s [GetSep index.vst $f]; getscl $f e; close $f
 set ivsel_v "$e"; set intext [getvalue $e 0 $s]
 set index [getvalue $e 1 $s]; set inoptions [getvalue $e 2 $s]
 if [winfo exists $Wi.c.f.f.li] {selection clear $Wi.c.f.f.li}
}

proc vstr_syntax {} {
 global Ws sytext syntax syoptions svsel_v
 set f [open_vst syntax.vst]; set s [GetSep syntax.vst $f]; getscl $f e; close $f
 set svsel_v "$e"; set sytext [getvalue $e 0 $s]
 set syntax [getvalue $e 1 $s]; set syoptions [getvalue $e 2 $s]
 if [winfo exists $Ws.c.f.f.li] {selection clear $Ws.c.f.f.li}
}

proc vstr_bibtex {} {
 global Wb bibtex bitext bioptions bvsel_v
 set f [open_vst bibtex.vst]; set s [GetSep bibtex.vst $f]; getscl $f e; close $f
 set bvsel_v "$e"; set bitext [getvalue $e 0 $s]
 set bibtex [getvalue $e 1 $s]; set bioptions [getvalue $e 2 $s]
 if [winfo exists $Wb.c.f.f.li] {selection clear $Wb.c.f.f.li}
}

proc vst_getvalues {w vstdat} {# Voreinstellungen lesen - Werte aus Datei lesen
#
  global vv vst_dir tclversion
  global version_vst texsuffix esuff
  global editor edtext edxterm edoptions edsyntaxhelp edback
  global index intext inoptions
  global logform logtext logxterm logoptions logback lsuff
  global preview prtext prsuffix proptions prformat prpreopt prback
  global printer lpcmd lpopt prtdriver prtselstr prtoptions
  global prtsuf prtreversed prtfilperm prtpresel prmtext prmsel prmrelabs
  global spcmd sptext splang spcorr spselect spoptions
  global syntax sytext syoptions
  global bibtex bitext bioptions
  global texfmt texfmtt texmem texmtext texmax quickenable quickverbatim quickprereq 
  global quickpreform quicksuffix quickpreamble quickendpre quickenddoc
  global aufmax aufsuff auftoggle
  global mkcommand fsmenucols
  global hlp_bmsuppr bell_level textxscroll geom
  global texlogatext texloganalyze texlogopts tlOfull tlHBad tlMaxL

  if {$vstdat==""} {
    vstr_exec exit;  vstr_editor;  vstr_tex;  vstr_preview;  vstr_logfile;  vstr_cleanup
    vstr_printer;  vstr_spell;  vstr_syntax;  vstr_index;  vstr_bibtex
  } else {
    if {$w != ""} {writescr0 $w "$vv(xt28) $vstdat\n\n"}
    set f [open $vstdat r]
    global efile
    while {[getscl0 $f z]>0} {
	set z "[string trim $z] "; set p [string first " " $z]
	set [crange $z 0 $p-1] [string trim [crange $z $p end]]
    }
    close $f
    if {($tclversion>=7.5)&&($mkcommand=="mkcommand.3")} {vstr_exec exit}
  }
  progback  editor  edback; progback  preview prback; progback  logform logback

}

proc vstReadDriver {} {
  global oldsuff texsuffix main_file
  set oldsuff $texsuffix
  vstRead .d.tt eigene.vst
  if {($oldsuff!="")&&($oldsuff!=$texsuffix)} {set main_file ""}
  MkcmdSource;  knoepfe
}

proc vstRead {w vst_file} {# Voreinstellungen lesen
#
  global  version_vst main_file dir efile env vstdat prvformat prformat opsep
  global  prtoptions olsep lpopt editor edback preview logform logback
  global  logxterm edxterm logoptions edoptions version_incompatible language logtext
  global  vst_dir

  set version_vst 0.00
  if {$vst_file=="default.vst"}  {# "Grund-Voreinst."
    set vstdat ""
  } else                            {# "Start/eigene Voreinst."
    if {($main_file=="")&&[file exists .lastxtem]} {
	set f [open ".lastxtem" r]
	while {[getscl $f e]>0} {mtest $e dir; mtest $e main_file; mtest $e efile}
	close $f
	if {$efile==""} {set efile $main_file}
    } elseif {($main_file!="")&&[file exists .lastxtem]} {
	set f [open ".lastxtem" r]; getscl $f zd; getscl $f zm; getscl $f ze; close $f
        if {[lindex $zm 1]=="$main_file"} {set efile [lindex $ze 1]}
    }
    if {($main_file!="")&&[file exists "${main_file}_$language.vst"] \
      &&($vst_file!=".xtem_$language.vst")} {
	set vstdat ${main_file}_$language.vst
    } elseif {[file exists "$env(HOME)/.xtem_$language.vst"]} {
	set vstdat "$env(HOME)/.xtem_$language.vst"
    } else {
	set vstdat ""
    }
  }
  TestPut 3 "vstdat=<$vstdat>"
  vst_getvalues $w $vstdat
  update_prtformat
  set prvformat $prformat
  set opsep [string index $prtoptions 0]; set olsep [string index $lpopt 0]
  if {$logform=="\$editor"} {
    set logxterm $edxterm; set logform $editor; set logback $edback; set logoptions $edoptions
    set logtext ""
  }
  if {$w!=""} {disp_prefs1 $w}
  set r 0
  if {[string range $version_vst 0 3]<=$version_incompatible} {
    if {$vstdat!=""} {frename $vstdat $vstdat.bak; set r $vstdat}
  }
  if {$vstdat==""} {set vstdat $vst_dir/*.vst}
  return $r
}


proc update_prtformat {} {
  global  prtselstr prtformat
  set prtformat [string trim [lindex [split $prtselstr ","] 3]]
}


proc lastxtem_write {} {
  global dir main_file efile
  set f [open ".lastxtem" w]
  puts $f "dir        $dir"
  puts $f "main_file  $main_file"
  puts $f "efile      $efile"
  close $f
}


proc vst_write {win} {# Voreinstellungen sichern
#
  global vv Wq main_file env language mkcommand

  if {$mkcommand=="mkcommand.9"} {writescr0 .d.tt "\n*** $vv(ut15)"; mybell 3; return}
  if {[string length $main_file]>0} {
    vst_write_file "${main_file}_$language.vst"
    lastxtem_write
    writescr0 $win "$vv(ut16) ${main_file}_$language.vst $vv(ut17)\n\n"
    set frage "[eval list $vv(ut18)]"
    if {[winfo exists $Wq]} {destroy $Wq}; toplevel $Wq
    set frage1 "[eval list $vv(ut18)]";  set frage2 "[eval list $vv(ut19)]"
    proc utReqSVstYes {} {
      global vv Wq env language
      destror $Wq
      vst_write_file "$env(HOME)/.xtem_$language.vst"
      writescr0 .d.tt "$vv(ut16) $env(HOME)/.xtem_$language.vst $vv(ut17)\n\n"
      disp_prefs1 .d.tt
    }
    proc utReqSVstNo  {} {global Wq; destror $Wq}
    Request $Wq "$frage1" "$frage2" "$vv(yes)" utReqSVstYes "$vv(no)" utReqSVstNo ut_saven ""
  } else {
    vst_write_file "$env(HOME)/.xtem_$language.vst"
    writescr0 $win "$vv(ut16) $env(HOME)/.xtem_$language.vst $vv(ut17)\n\n"
  }
  disp_prefs1 $win
}


proc vst_write_file {vst_file} {# Voreinstellungen in vst-Datei schreiben
#
  global mkcommand fsmenucols version dir main_file efile edback prback env language
  global editor edtext edxterm edoptions edsyntaxhelp esuff
  global printer prtselstr prtdriver prtpresel prtoptions prtsuf
  global lpcmd lpopt
  global spcmd sptext splang spoptions spcorr spselect
  global index intext inoptions syntax sytext syoptions
  global preview prsuffix proptions prformat prtext prpreopt
  global bibtex bitext bioptions
  global texfmt texfmtt texmtext texmem texmax texsuffix quickenable quickverbatim 
  global quickprereq quickpreform quicksuffix quickpreamble quickendpre quickenddoc
  global aufmax aufsuff auftoggle logform logtext logxterm logoptions logback lsuff
  global prmtext prmsel prmrelabs prtreversed prtfilperm
  global hlp_bmsuppr bell_level textxscroll geom
  global texlogatext texloganalyze texlogopts tlOfull tlHBad tlMaxL

  set geom(xtem) [wm geometry .]
  set f [open "$vst_file" w]
  puts $f "version_vst  $version"
  if {"$vst_file" != "$env(HOME)/.xtem_$language.vst"} {
    puts $f "dir  $dir"
    puts $f "main_file  $main_file"
    puts $f "efile  $efile"
  }
  puts $f "editor  $editor$edback"; puts $f "edtext  $edtext"
  puts $f "edxterm  $edxterm";  puts $f "edoptions  $edoptions"
  puts $f "edsyntaxhelp  $edsyntaxhelp"; puts $f "esuff  $esuff"
  puts $f "index  $index"; puts $f "intext  $intext"; puts $f "inoptions  $inoptions"
  puts $f "logform  $logform$logback"; puts $f "logtext  $logtext"
  puts $f "logxterm  $logxterm"; puts $f "logoptions  $logoptions"; puts $f "lsuff  $lsuff"
  puts $f "preview  $preview$prback"; puts $f "prtext  $prtext"
  puts $f "prsuffix  $prsuffix"; puts $f "proptions  $proptions"
  puts $f "prformat  $prformat"; puts $f "prpreopt  $prpreopt"; puts $f "printer  $printer"
  puts $f "lpcmd  $lpcmd"; puts $f "lpopt  $lpopt"; puts $f "prtdriver  $prtdriver"
  puts $f "prtselstr  $prtselstr"; puts $f "prtoptions  $prtoptions"
  puts $f "prtreversed  $prtreversed"; puts $f "prtfilperm  $prtfilperm"
  puts $f "prtsuf  $prtsuf"; puts $f "prtpresel  $prtpresel"; puts $f "prmtext  $prmtext"
  puts $f "prmsel  $prmsel"; puts $f "prmrelabs  $prmrelabs"
  puts $f "spcmd  $spcmd"; puts $f "sptext  $sptext"; puts $f "splang  $splang"
  puts $f "spcorr  $spcorr"; puts $f "spselect  $spselect"; puts $f "spoptions  $spoptions"
  puts $f "syntax  $syntax"; puts $f "sytext  $sytext"; puts $f "syoptions  $syoptions"
  puts $f "bibtex  $bibtex"; puts $f "bitext  $bitext"; puts $f "bioptions  $bioptions"
  puts $f "texfmt  $texfmt"; puts $f "texfmtt  $texfmtt"; puts $f "texmem  $texmem"
  puts $f "quickenable  $quickenable"; puts $f "quickverbatim  $quickverbatim"
  puts $f "quickprereq  $quickprereq"; puts $f "quickpreform  $quickpreform"
  puts $f "quicksuffix  $quicksuffix"; puts $f "quickpreamble  $quickpreamble"
  puts $f "quickendpre  $quickendpre"; puts $f "quickenddoc  $quickenddoc"
  puts $f "texmtext  $texmtext"; puts $f "texmax  $texmax"; puts $f "texsuffix  $texsuffix"
  puts $f "texlogatext  $texlogatext"; puts $f "texloganalyze  $texloganalyze"
  puts $f "texlogopts  $texlogopts"; puts $f "tlOfull  $tlOfull"; puts $f "tlHBad  $tlHBad"
  puts $f "tlMaxL  $tlMaxL"
  puts $f "aufmax  $aufmax"; puts $f "aufsuff  $aufsuff"; puts $f "auftoggle  $auftoggle"
  puts $f "mkcommand  $mkcommand"; puts $f "hlp_bmsuppr  $hlp_bmsuppr"
  puts $f "fsmenucols  $fsmenucols"; puts $f "bell_level  $bell_level"
  puts $f "textxscroll  $textxscroll"
  if [info exists geom] {foreach k [array names geom] {puts $f "geom($k) $geom($k)"}}
  close $f
}


proc disp_prefs1 {win} {# aktuelle Einstellungen anzeigen (ohne Dateien)
#
  global  vv editor edback edtext esuff texfmt texmtext texmax preview prback
  global  logform logback printer prtdriver prmtext spcmd syntax index bibtex
  global  mkcommand prformat prtformat

  writescr .d.tt " $vv(ut20) $editor$edback  $edtext" \
	[alternative $edback "\n" "   $vv(ut21)\n"] \
	"    $vv(ut200)" [alternative $esuff " *\n" " $esuff\n"] \
	" $vv(ut22) $texfmt\n    $vv(ut23) $texmtext\n    $vv(ut24) $texmax\n" \
	" $vv(ut25) $preview$prback" \
	[alternative $prback "" "   $vv(ut21)"]  ", $prformat\n" \
	" $vv(ut26) $logform$logback\n $vv(ut27) $printer\n" \
	" $vv(ut28) $prtdriver,  $prtformat\n $vv(ut29) $prmtext\n $vv(ut30) $spcmd\n" \
	" $vv(ut31) $syntax\n $vv(ut34) $index\n $vv(ut32) $bibtex\n $vv(ut33) $mkcommand\n\n"
}


proc disp_prefs2 {win} {# aktuelle Einstellungen anzeigen (mit Dateien)
#
  global  vv main_file efile texfmt esuff tsuff

  disp_prefs1 $win
  writescr .d.tt [alternative $efile " $vv(bad1)\n" " $vv(bad2) $efile$esuff\n"] \
	[alternative $main_file " $vv(tvbad1) $texfmt $vv(tvbad3)\n" \
	  " $vv(tvbad2) $texfmt $vv(tvbad3): $main_file$tsuff\n"]
}


proc ConfigText {w t} {if [winfo exists $w] {$w configure -text $t}}


proc LockButtons {args} {foreach i $args {$i configure -state disabled}; update idletasks}


proc UnlockButtons {args} {foreach i $args {$i configure -state normal}; update idletasks}


proc lock {} {# Verriegeln aller Buttons des Hauptmenues
#
  global gesliste anl0

  set anl0 1
  set nmax [llength $gesliste]
  while {$nmax>0} {incr nmax -1;  [lindex $gesliste $nmax] configure -state disabled}
  update idletasks
}


proc unlock {args} {# Entriegeln der angegebenen Buttons (bel. viele)
#
  global sub anl0

  foreach i $args {
    set k [llength $i]
    while {$k>0} {incr k -1; set ll [lindex $i $k]; $ll configure -state normal}
  }
  set sub 0
  set anl0 0
}


proc unlock_list {} {# Entriegeln der Buttons der globalen Liste
#
  global Wo liste edsubback prsubback quickenable

  if [winfo exists $Wo] {return}

  if {([edactiv]==0)&&($edsubback>0)} {
    set edsubback 0
    if {[lsearch $liste .c.1.ed]<0} {set liste [linsert $liste 1 .c.1.ed]}
  }
  if {([practiv]==0)&&($prsubback>0)} {
    set prsubback 0
    if {[lsearch $liste .c.1.pf]<0} {set liste [linsert $liste 1 .c.1.pf]}
  }
  unlock $liste
  if {!$quickenable} {.c.1.qd configure -state disabled; update}
}


proc edactiv {} {#  Kontrolle, wieviele Editor-Prozesse im Background aktiv
#
  global edliste

  set l [llength $edliste]
  while {$l>0} {
   incr l -1
   set p [lindex $edliste $l]
   if {[process $p]!=0} {set edliste [lreplace $edliste $l $l]};# Prozess $p nicht mehr aktiv!
  }
  return [llength $edliste]
}


proc practiv {} {#  Kontrolle, wieviele Editor-Prozesse im Background aktiv
#
  global prliste

  set l [llength $prliste]
  while {$l>0} {
   incr l -1
   set p [lindex $prliste $l]
   if {[process $p]!=0} {set prliste [lreplace $prliste $l $l]};# Prozess $p nicht mehr aktiv!
  }
  return [llength $prliste]
}


proc DestroyAfterKillEtc {prozessliste} {# kill processes, delete files, destroy xtem
#
  if {[llength $prozessliste]!=0} {
    foreach pi $prozessliste {killprocess $pi}
    update
    signal block SIGCHLD; exec sleep 1; signal unblock SIGCHLD
  }
  QuickFileDel
  signal default SIGCHLD
  destroy .
}


proc open_vst {filename} {# open for a .vst-file
#
  global xtem_path vst_dir language env 

  if {[info exists env(XTEMVSTDIR)]} {
    if {[file exists $env(XTEMVSTDIR)/$filename]} {
      set f [open "$env(XTEMVSTDIR)/$filename" r]
      set vst_dir $env(XTEMVSTDIR)
    } else {
      set f [open "$xtem_path/locals_$language/$filename" r]
      set vst_dir $xtem_path/locals_$language
    }
  } else {
    set f [open "$xtem_path/locals_$language/$filename" r]
    set vst_dir $xtem_path/locals_$language
  }
  return $f

}


proc format_switch {w fmtneu mod} {# switch format (e.g. portrait/landscape)
                                   # for preview and printing
  global vv Wp Wdv prformat prtext prvformat prvfmtli pvnoend prtselstr prtformat prtfmtli

  set fmtlisten 0

  if {$w=="$Wdv.d.tt"} {
    if {[winfo exists $Wp]} {writescr0 $Wp.d.tt ""}
  } else {
    if {[winfo exists $Wdv]} {writescr0 $Wdv.d.tt ""}
  }

  set prfmtalt "$prvformat"
  if {($mod==1)||($mod==3)} {
    if {$fmtneu==$prfmtalt} {# no format change necessary (old = new)
      writescr $w "$prvformat $vv(pvfe)\n"
    } else {# format has to be changed (old /= new)
      set prres [prv_select "$prtext, $prformat" "$fmtneu"]
      set prvformat $fmtneu
      if {$prres} {# preview format changed
        if {$w=="$Wdv.d.tt"} {writescr $w "$vv(ut35)\n$vv(ut35a)\n $prtext, $prformat\n\n"}
        if {[winfo exists $Wp]} prvlistfill
      } else {# preview format could not be changed; only update preview list
        writescr $w "$vv(ut37)\n$vv(ut38)\n$vv(ut39)\n\n"
        if {[winfo exists $Wp]} prvlistfill
        mybell 3; set fmtlisten 1; set pvnoend 1
      }
    }
  }

  set prtfmtalt "$prtformat"
  if {$mod>=2} {
    if {$fmtneu=="$prtfmtalt"} {# no format change necessary (old = new)
      writescr $w "$prtformat $vv(dvfe)\n"
    } else {# format has to be changed (old /= new)
      set prtres [prt_select "$prtselstr" "$fmtneu"]
      if {$prtres} {# printer format changed
        if {$w=="$Wp.d.tt"} {writescr $w "$vv(ut36)\n$vv(ut36a)\n $prtselstr\n\n"}
      } else {# printer format could not be changed
        writescr $w "$vv(ut40)\n$vv(ut41)\n$vv(ut42)\n\n"
        mybell 3; set fmtlisten 1; set pvnoend 1
      }
    }
  }

  if {$fmtlisten} {
    writescr $w "$vv(ut43) ($prtext):\n$prvfmtli\n"
    writescr $w "$vv(ut44) ($prtselstr):\n$prtfmtli\n"
  }
}


proc InsertTextFrame {w tyh} {# text frame for help/program output
 global textxscroll
 frame $w.d -relief raised -borderwidth 2
 pack configure $w.d -anchor sw -fill both -expand true
 if {($textxscroll>1)||(($textxscroll>0)&&($w==""))} {
   text $w.d.tt -height $tyh -yscrollcommand [list $w.d.yb set] \
		  -wrap none -xscrollcommand [list $w.d.xb set]
   scrollbar $w.d.xb -orient horizontal -command [list $w.d.tt xview]
   pack configure $w.d.xb -side bottom -fill x
   Bind3HF $w.d.xb z_textfeld $w.d.tt
 } else {
   text $w.d.tt -height $tyh -yscrollcommand [list $w.d.yb set]
 }
 scrollbar $w.d.yb -orient vertical -command [list $w.d.tt yview]
 pack configure $w.d.yb -side right -fill y
 pack configure $w.d.tt -side left -fill both -expand true
 Bind3HF $w.d.yb z_textfeld $w.d.tt
 Bind3HF $w.d.tt z_textfeld $w.d.tt
 $w.d.tt configure -state disabled
}


proc insertTopButtons {w h endCom args} {# inserts 3 top buttons: exit, help, clear -> $w.a
 global vv hlp_dir

 if {$args==""} {set wh $w.d.tt} {set wh $args}
 frame $w.a -relief raised -borderwidth 1; pack configure $w.a -pady 3 -anchor nw
 
 button $w.a.e -text "$vv(ae)" -command $endCom
 button $w.a.h -text "$vv(ah)" -command "cat_file0 ${hlp_dir}$h.hlp $wh"
 button $w.a.l -text "$vv(al)" -command "clearscr $wh"
 pack configure $w.a.e $w.a.h $w.a.l -side left -padx 3 -pady 3
 Bind3HF $w.a.e z_vstquit $wh
 Bind3HF $w.a.h z_help $wh
 Bind3HF $w.a.l z_loeschetf $wh
}



proc vst2list {file skip sep text var} {# read help-file, return as list
  global [set var]
  if ![info exists [set var]] {set [set var] ""}
  set f [open_vst $file]
  for {set s 1} {$s<=$skip} {incr s} {getscl $f e}
  set l ""
  while {[getscl $f e]>0} {
    lappend l $e
     if {$text==[getvalue $e 0 $sep]} {eval set [set var] \"\$e\"}
		# do not evaluate $e here (e.g because of $HOME in spell.vst)!
  }
  close $f
  return "$l"
}


proc CreateLSBox {w text s wi he bw hf hw sep list com sel sele args} {
# creates frame w.f and title for selection, fills with list
# creates selection box + scrollbar or radiobuttons; width wi, height he; help-text hf in hw
#
  global vv hlp_dir [set com]_v lastclick button2end

  set ldist 4
  foreach a $args {set [lindex $a 0] [lindex $a 1]}

  frame $w.f; pack configure $w.f -anchor w -padx $ldist -fill x -expand yes
  if {$text!=""} {
    label $w.f.l -text $text; pack configure $w.f.l -side $s -anchor w
    if {$hf!=""} {Bind3HTF $w.f.l "$vv(btclk1):\n" $hf $hw}
  }
  frame $w.f.f -relief raised -borderwidth $bw
  pack configure $w.f.f -anchor w -fill x -expand yes
  if {($sele!="")&&($button2end==2)} {set hp "$vv(btclk2):\n  $vv(btclk3)\n"} else {set hp ""}
  set hp "${hp}$vv(btclk1):\n"
  if {[regexp "sel0*" "$sel"]||([llength $list]>$he)} {
    scrollbar $w.f.f.sb -command "$w.f.f.li yview"
    if {$sel=="sel0"} {set sc ""} {set sc "$w.f.f.sb set"}
    listbox $w.f.f.li -yscrollcommand "$sc" -width $wi -height $he
    pack configure $w.f.f.sb -side right -fill y
    pack configure $w.f.f.li -side right -fill y -fill x -expand yes
    if {$list!=""} then {foreach e $list {$w.f.f.li insert end $e}}
    if {$hf!=""} {Bind3HTF $w.f.f.sb "$hp" $hf $hw; Bind3HTF $w.f.f.li "$hp" $hf $hw}
    if {$sel=="sel0"} {destroy $w.f.f.sb}
    bind $w.f.f.li <Leave> Bend
    bind $w.f.f.li <Double-Button-1> Bend
    bind $w.f.f.li <Triple-Button-1> Bend
    eval bind $w.f.f.li <Button-1> \
		\{set lastclick $w.f.f.li\; [set com] \[Selektion %W %y\]\; Bend\}
    if {($sele!="")&&($button2end==2)} {
	eval bind $w.f.f.li <Button-2> \
		\{set lastclick $w.f.f.li\; [set com] \[Selektion %W %y\]\; Bend\}
	eval bind $w.f.f.li <ButtonRelease-2> \{after 200\; $sele\; Bend\}
    }
  } else {
    set i 0
    foreach e $list {
      incr i
      radiobutton $w.f.f.$i -width $wi -anchor w -text [getvalue $e 0 $sep] \
	-variable [set com]_v -value "$e" -command "set lastclick $w.f.f.$i; [set com] \{$e\}"
      if {($sele!="")&&($button2end==2)} \
	      {bind $w.f.f.$i <Button-2> "$w.f.f.$i invoke; after 300; $sele"}
      pack configure $w.f.f.$i -anchor nw
      if {$hf!=""} {Bind3HTF $w.f.f.$i $hp $hf $hw}
    }
  }
}


proc dirMainFile {} {# if main-filename is prefixed by directory: cd if possible
  global vv Wf Wq main_file efile esuff texsuffix dirprefix dir Wf

  set dirprefix ""; set ret 0
  if {[string last / $main_file]>=0} {# filename is prefixed by directory
    set d [crange $main_file 0 [string last / $main_file]-1]
    set f [crange $main_file [string last / $main_file]+1 end]
    if {[file isdirectory $d]&&[file readable $d]&&[file writable $d]&&[file executable $d]} {
      cd $d; set dir [pwd]; set ret 1; if [winfo exists $Wf] {dirselected $dir $f}
      set main_file $f; set efile $f; set esuff $texsuffix
      if [winfo exists $Wf] {fsanzeige $Wf}
    } elseif {($d!="")&&![file exists $d]} {
      mkdcdfill "$d" "$f" main; set ret 1
    } else {
      set dirprefix $d
    }
  }
  return $ret
}


proc mkdcdfill {nd nf type} {# aks whether to create nd (and creates it on request)
  global Wf Wq vv mkdcdfill_nd mkdcdfill_nf mkdcdfill_type

  set mkdcdfill_nd "$nd"; set mkdcdfill_nf "$nf"; set mkdcdfill_type "$type"
  if [winfo exists $Wf.d.tt] {set wt $Wf} else {set wt ""}
  if [string match "* *" $nd] {writescr0 $w "$vv(ut45)!"; mybell 3; return}
  regsub -all "//+" "$nd" "/" nd;  set nd [string trimright $nd /]

  if {[winfo exists $Wq]} {destroy $Wq}; toplevel $Wq
  set frage1 "$vv(fs20) \"$nd\" $vv(ea4)   $vv(fs21)?"; set frage2 ""
  proc ReqCDirYes {} {
    global vv Wq Wf mkdcdfill_nd mkdcdfill_type mkdcdfill_nf efile
    destror $Wq
    set res [catch "mkdir -path $mkdcdfill_nd" mes]
    if {$mes!=""} {
      if [winfo exists $Wf.d.tt] {set w $Wf.d.tt} else {set w .d.tt}
      writescr $w "\n*** $vv(ut46):\n $mes\n "; mybell 3
    } elseif {$mkdcdfill_type=="main"} {
      dirselected $mkdcdfill_nd $mkdcdfill_nf
    } elseif {$mkdcdfill_type=="edit"} {
      set efile "[fsdirCheckClear $mkdcdfill_nd]$mkdcdfill_nf"
      if [winfo exists $Wf.c.e.i] {$Wf.c.e.i delete 0 end}
      if {$efile==""} {writescr0 $Wf.d.tt "$vv(fs19) = $vv(fs5)\n"} \
      else {writescr0 $Wf.d.tt "$vv(fs19) $efile\n"}
      fsfuellen edit
      fsanzeige $Wf
    }
  }
  proc ReqCDirNo  {} {global Wq; destror $Wq}
  Request $Wq "$frage1" "$frage2" "$vv(yes)" ReqCDirYes "$vv(no)" ReqCDirNo ut_createdir "$wt"
}


proc dirselected {d f} {# fills the directory selection box; sets files to f
  global vv env Wf dir main_file efile esuff texsuffix liste dirprefix

  if {$d=="\$HOME"} {set cdir $env(HOME)} else {set cdir $d}
  if [winfo exists $Wf] {set w $Wf.d.tt} else {set w .d.tt}
  if {[catch {cd $cdir} m]!=0} {
    mybell 2;  set dir [pwd];  writescr0 $w "$vv(tvt2)\n$vv(tvt3)\n$m\n"
    return 0
  } else {
    set dirprefix ""
    writescr0 $w "$vv(tvt4) [pwd]\n\n"
    set dir [pwd]
    if {$f==""} {set main_file ""} else {set main_file $f}
    set efile "$main_file"; set esuff $texsuffix
    knoepfe
    if {[winfo exists $Wf]} {
      fsanzeige $Wf
      if {[lsearch $liste .c.1.ed]<0} {set liste [linsert $liste 1 .c.1.ed]}
      if {[lsearch $liste .c.1.pf]<0} {set liste [linsert $liste 1 .c.1.pf]}
      if [winfo exists $Wf.c.d] {
      $Wf.c.d.f.f.li delete 0 end; $Wf.c.d.f.f.li insert end "\$HOME" ".."
	foreach k [lsort [glob -nocomplain -- *]] \
	  {if [file isdirectory $k] {$Wf.c.d.f.f.li insert end $k}}
      }
      fsfuellen main; fsfuellen edit
    }
    return 1
  }
}


proc which {command} {
  global env whichcheck
  if {$whichcheck=="yes"} {
    foreach dir [split $env(PATH) :] {
      set path ${dir}/${command}
      if {[file isfile $path]&&[file executable $path]} {return $path}
    }
    return -code error \
		-errorinfo "$command not found in [split $env(PATH) :]" "$command not found"
  }
}


proc knoepfe {} {
  global  vv editor efile esuff texfmt main_file tsuff preview psuff printer asuff
  global  logform logback lsuff prtdriver texsuffix prsuffix quickfile quickenable
  global  spcmd spsuff syntax ssuff index isuffe bibtex edback prback b_letters

  if {$main_file==""} {
    set tsuff "";  set psuff "";  set lsuffd "";  set asuff ""; set quicktext ""
  } else {
    set tsuff $texsuffix;  set psuff $prsuffix;  set lsuffd $lsuff;  set asuff .dvi
    set quicktext "$main_file -> $quickfile$tsuff"
  }
  if {[fileName $efile]==""} {set esuffl ""} else {set esuffl $esuff}
  set spsuff "$esuffl";  set ssuff  "$esuffl"
  set efn "[fileName $efile]";  set efp "[filePrefix $efile]"
  if {$efn==""} {set efilel ""} \
  elseif {($efp=="")||($efp=="/")||($efp=="[pwd]/")} {set efilel "$efn"} \
  else {set efilel "..../$efn"}

  .c.1.ed configure -text "$vv(xtc1ed) $editor$edback $efilel$esuffl"
  .c.1.qd configure -text "$vv(xtc1qd) $texfmt $quicktext"
  .c.1.la configure -text "$vv(xtc1la) $texfmt $main_file$tsuff"
  .c.1.pf configure -text "$vv(xtc1pf) $preview$prback $main_file$psuff"
  .c.1.as configure -text "$vv(xtc1as) $prtdriver $main_file$asuff -> $printer"
  .c.2.re configure -text "$vv(xtc2re) $spcmd $efilel$spsuff"
  .c.2.sy configure -text "$vv(xtc2sy) $syntax $efilel$ssuff"
  .c.2.in configure -text "$vv(xtc2in) $index $main_file"
  .c.2.bi configure -text "$vv(xtc2bi) $bibtex $main_file"
  .c.2.fl configure -text "$vv(xtc1fl) $logform$logback $main_file$lsuffd"
  .c.2.le configure -text "[string trim [crange $b_letters 1 end]]"
  if {!$quickenable} {.c.1.qd configure -state disabled; update}
}


proc filePrefix {file} {# returns prefix (=directory) of file
  set p [string last "/" $file];  if {$p<0} {return ""} else {return "[crange $file 0 $p]"}
}

proc fileName {file} {# returns filename (without directory-prefix) of file
  set p [string last "/" $file]
  if {$p<0} {return "$file"} else {return "[crange $file $p+1 end]"}
}

proc Selektion {W y} {# selection for list boxes (y=B1 (y coordinate) within widget W)
  set i [$W nearest $y]
  $W selection clear 0 end;  $W selection set $i
  return [$W get $i]
}


proc Bend {} {return -code break; # procedure to break resp. nullify bindings}


proc MkcmdTclVCol {notfound} {# returns column number in mkcommand.vst applying to Tcl version
	# tclversion/tclVersion must start with 3rd word in a column in 1st line of file
 global vv tclversion tclVersion vst_dir MkcmdTclVColNr stt

 if [info exists MkcmdTclVColNr] {return $MkcmdTclVColNr}; # second call

 # first call: set MkcmdTclVColNr
 set f [open_vst mkcommand.vst]; getscl $f e; close $f
 set s [string index [string trim $e] 0]
 for {set n 1} {[string trim [getvalue $e $n $s]]!=""} {incr n} {set lastCol $n}
 for {set n 1} {$n<=$lastCol} {incr n} {
   if {"[string trim [getvalue $e $n $s]]"=="Tcl_$tclversion"} \
							{set MkcmdTclVColNr $n; return $n}
   if {"[lindex [getvalue $e $n $s] 0]"=="$tclversion"} {set MkcmdTclVColNr $n; return $n}
   if {"[lindex [getvalue $e $n $s] 1]"=="$tclversion"} {set MkcmdTclVColNr $n; return $n}
   if {"[lindex [getvalue $e $n $s] 2]"=="$tclversion"} {set MkcmdTclVColNr $n; return $n}
   if {[regexp "^Tcl.*${tclversion}$" [getvalue $e $n $s]]} {set MkcmdTclVColNr $n; return $n}
 }
 for {set n 1} {$n<=$lastCol} {incr n} {
   if {[string first $tclversion [getvalue $e $n $s]]>=0} {set MkcmdTclVColNr $n; return $n}
 }
 if {"$notfound"=="exit"} {
   set tl1 "\n$vv(errf) $vst_dir/mkcommand.vst\n"
   set tl2 "    ($vv(ut53) $tclversion)\n    $vv(adm)\n"
   set tl3 "    ($vv(ut54) [getvalue $e $lastCol $s] ($lastCol) $vv(ut55)!)\n"
   puts stdout "$tl1$tl2"; set stt "${stt}$tl1$tl2"
   mybell 4
   # don't exit, better to use last column, if existing!
   if {$lastCol>=1} {
     puts stdout "$tl3"; set stt "${stt}$tl3"
     set MkcmdTclVColNr $lastCol; return $lastCol
   } else {
     exit
   }
 } else {
   return 0
 }
}


proc fa2a {} {
  global vv sub p_mkCmd lp_mkCmd
  button .a.2.a -text "$vv(xta2a)" -command {#            Abbruch
    if {$xtAbbruch==2} {# Abbruch von Prozeduren wie z.B tla (TeX Logfile Analyse)
      set xtAbbruch 1
    } else {
      if {$sub==1} {
	set lp_mkCmd $p_mkCmd; mybell 2
        if {$lp_mkCmd>1} \
	  {writescr .d.tt "\n\n[datime] $vv(xt4) $lp_mkCmd $vv(xt5)\n";killprocess $p_mkCmd} \
        elseif {$lp_mkCmd==1} {writescr .d.tt "\n\n[datime] $vv(xt6)\n"} \
        else {destror $Wq; set wait_mkCmd 1}
        unlock_list
      } else {
        writescr .d.tt "\n\n[datime] $vv(xt7)\n\n$vv(xt8)\n";  mybell 2
      }
    }
  }
  Bind3HF .a.2.a xt_abbruch .d.tt
  pack configure .a.2.a -side left -padx 3 -pady 3
  .a.2.a configure -state disabled; update idletasks
}

proc MkcmdSource {} {
  global  vv Wq mkcommand xtem_path tclversion
  MkcmdTclVCol exit
  set mkctyp [crange $mkcommand 0 10]
  if [file exists "mkcommand_tst"] {set mkcommand "mkcommand_tst} \
  else {
    if     [file exists $xtem_path/${mkctyp}_tcl$tclversion] \
		{set mkcommand     ${mkctyp}_tcl$tclversion} \
    elseif [file exists $xtem_path/$mkctyp] \
		{set mkcommand     $mkctyp} \
    else        {set mkcommand mkcommand.9}
  }
  source $xtem_path/$mkcommand
  if {[regexp {^mkcommand\.[0,5]} $mkctyp==""]} {
    if  [winfo exists .a.2.a] {destroy .a.2.a; update idletasks}
    if  [winfo exists .a.2.x] {.a.2.x invoke; destroy .a.2.x; update idletasks}
  } elseif {$mkctyp=="mkcommand.4"} {
    if ![winfo exists .a.2.a] fa2a
    if ![winfo exists .a.2.x] mkCmd_cw
    XhostTest .d.tt "\n**** "
  } else {
    if ![winfo exists .a.2.a] fa2a
    if  [winfo exists .a.2.x] {.a.2.x invoke; destroy .a.2.x; update idletasks}
  }
}


proc XhostTest {f str} {# procedure to test, whether send command is supposed to work here
  global vv
  signal block SIGCHLD; set xherg [catch "exec xhost" xhostres]; signal unblock SIGCHLD
  if "$xherg" {
    if {$f!=""} {writescr $f "\n$str$vv(ut47)!\n\n"; mybell 3};  
    return -1
  } else {
    if {[string first \n $xhostres]>0} {set nl 9999} else {set nl 1}
    set beg [lrange $xhostres 0 7]
    if {([string first enabled $beg]>0)&&($nl>1)} \
	    {writescr $f "\n$str$vv(ut48)\n$vv(ut49)\n$vv(ut50)!\n\n"; mybell 3}

  }
}


proc AnzCharIn {c string} {
 set n 0
 if {$c=="z"} {set s "${string}x"} else {set s "${string}z"}
 while {[string first $c $s]>=0} {incr n; set s [crange $s [string first $c $s]+1 end]}
 return $n
}


proc CheckNumInt {num} {# checks, if num is integer number: return 0 if not; else ...
  set n "x$num"
  if {($n=="x0") ||[regexp {^x[1-9]+[0-9]*$} $n]}     {return  1};# >=0 without sign
  if {($n=="x+0")||[regexp {^x[+]+[1-9]+[0-9]*$} $n]} {return  2};# >=0 with sign
  if {[regexp {^x[-]+[1-9]+[0-9]*$} $n]}              {return -1};# <0
  if {($n=="x-0")}                                    {return -2};# -0 (0 with sign!)
  return 0
}


proc CheckNumReal {num} {# checks, if num is real number: return 0 if not; else ...
 set n $num
 if {([string first + $n]==0)&&([string length $n]>1)} {set s +;set n [crange $n 1 end]} \
 elseif {([string first - $n]==0)&&([string length $n]>1)} {set s -;set n [crange $n 1 end]} \
 elseif {([string length $n]>0)} {set s ""} \
 else {return 0}
 if {(![regexp {^[0-9.]+$} $n])||([AnzCharIn "." $n]>1)} {return 0}
 catch "if {($n==.)} {return 0}"
 # now we know: $num is number, n contains only digits an at most 1 point, $s contains sign
 return ${s}1
}


proc TestPut {args} {
  global bell_level testPut
  if {([lrange $args 1 end]=="")||([lindex $args 0]<0)||([lindex $args 0]>4)} \
	{set s [lrange $args 0 end]; set l 4} \
  else  {set s [lrange $args 1 end]; set l [lindex $args 0]}
  if {($testPut>0)&&($l>=$bell_level)} \
	{puts stdout "*** [lindex [info level [expr [info level]-1]] 0]: \t<$s>";flush stdout}
}

proc getBefore {str pos} {# returns all characters from string before position or empty string
  if {$pos<=0} {return ""} else {return [crange $str 0 $pos-1]}
}


proc getAfter {str pos} {# returns all characters from string after position or empty string
  if {$pos>=[string length $str]} {return ""} else {return [crange $str $pos+1 end]}
}


proc getPreamble {file} {# set preamble (up to quickendpre) of file and returns 1 if found
  global preamble preamble_found quickpreamble quickendpre quickprereq
  set f [open $file r]; set app ""; set preamble ""; set preamble_found 0
  if {[gets $f zeile]=="-1"} {set suchen 0} \
  else                     {set suchen 1; set app $zeile}
  while {$suchen} {
    if {[string first "$quickendpre" "$zeile"]>=0} {# quickendpre in this line; comment only?
                                                          TestPut 3 "*****<$zeile>";#####@@@@@
      set app ""; set rest $zeile
      while {$rest!=""} {
	set p [string first "$quickendpre" "$rest"]
	if {$p>0} {set s1 [crange $rest 0 $p-1]} else {set s1 ""}
	set s2 [crange $rest $p end]
		TestPut 2 "<$rest> sl:<[string length "$rest"], p:<$p> <$s1><$s2>>";#####@@@@@
        if {(![CommentIncl "$s1"])||([string index "$quickendpre" 0]=="%")} {
	  # no comment in line before quickendpre or `ignore comment'
	  set app "$s1"; set rest ""; set suchen 0; set preamble_found 1
       TestPut 2 "yes: <$s1><[CommentIncl "$s1"]><[string index "$quickendpre" 0]>";#####@@@@@
        } else {
                                        TestPut 2 "no:  <$s1><[CommentIncl "$s1"]>";#####@@@@@
	  set app "$s1"
        }
      }
      if {$suchen} then {if {[gets $f zeile]=="-1")} then {set suchen 0}}
    } else {# no quickendpre in this line
      if {[gets $f zeile]=="-1"} {set suchen 0}
    }
                                                            TestPut 3 "+++++<$app>";#####@@@@@
    set preamble "${preamble}$app\n"; set app  $zeile
  }
  if {!$preamble_found} {if {!$quickprereq} {set preamble ""} {set preamble "$quickpreamble"}}
  close $f
}


proc CommentIncl {string} {# returns 1 if comment starts elsewhere in string, 0 otherwise
  set rest "$string"; set commInc 0
  while {$rest!=""} {
    set fbpr [string first {\%} "$rest"]; set fpro [string first {%} "$rest"]
    if {($fbpr>=0)&&($fbpr<$fpro)} {set rest [getAfter "$rest" [expr $fbpr+1]]; # \% first} \
    elseif {$fpro>0} {set rest ""; set commInc 1; # \% first}
  }
  return $commInc
}


proc QuickFileDel {} {# delete all Quick&Dirty files
  global quickfile
  set files [glob -nocomplain -- $quickfile.*]
  if {$files!=""} {foreach f $files {unlink -nocomplain $f}}
}


proc CheckSIGCHLDUnblocked {} {# checks whether SIGCHLD is unblocked
  if {[lindex [lindex [lindex [signal get SIGCHLD] 0] 1] 1]!=0} {signal unblock SIGCHLD}
}


proc CheckSIGCHLDBlocked {} {# checks whether SIGCHLD is blocked
  if {[lindex [lindex [lindex [signal get SIGCHLD] 0] 1] 1]==0} {signal block SIGCHLD}
}


proc CheckSIGCHLDInsecure {w} {# is SIGCHLD insecure? (Tcl7.5 & mkcommand: .1,.2,.3)
  global vv tclversion mkcommand

  if {$tclversion>=7.5} {# SIGCHLD is insecure 
			 # (does'nt come in any case after program termination)!
    writescr $w "\n$vv(xtq01)\n$vv(xtq28): $mkcommand\n" \
		"$vv(xtq29) $tclversion\n**\n$vv(xtq30)\n$vv(xtq31)\n**\n$vv(xtq32)\n" 
    mybell 2
  }
}
